#include <windows.h>
#include <iostream>
#include <tchar.h>

#define kLibraryKey "37D4A53841E124FA5ED24DF49B2D49A00936AF2AC4AFBD1DF87DF2DEF98F000FA27B3003BBE2"

int DisplayRegistrationDlg(LPCSTR aKeyCode, HWND aHWnd);

int main()
{
	std::cout << "Hello World!\n";

	int ret = DisplayRegistrationDlg(kLibraryKey, NULL);

	std::cout << "Goodbye World!\n";

	if (ret == -1)
		exit(0);
}

typedef UINT(__stdcall* TrialFcn)(LPCSTR, HWND);

// register function signature
typedef UINT(__stdcall* RegisterFcn)(LPCSTR, LPCWSTR);

int InitLicensingSupport(LPCSTR aKeyCode, HWND aHWnd)
{
	HMODULE hModule = ::LoadLibrary(_T("Trial.dll"));
	if (hModule == NULL)
		return -1; // Missing Trial DLL;

	TrialFcn readSettingsProc = reinterpret_cast<TrialFcn>(
		::GetProcAddress(hModule, "ReadSettingsStr"));

	if (readSettingsProc == NULL)
		return -1; // Missing Trial DLL;

	// Return values:
	// "0" - the application is registered (a valid license key was found);
	// "2" - the application is in trial mode;
	// If the application trial period has expired and the user will NOT enter
	// a valid license key, the process will be killed by the function
	// instead of returning one of the codes above.
	int ret = readSettingsProc(aKeyCode, aHWnd);

	return ret;
}

int DisplayRegistrationDlg(LPCSTR aKeyCode, HWND aHWnd)
{
	HMODULE hModule = ::LoadLibrary(_T("Trial.dll"));
	if (hModule == NULL)
	{
		std::cout << "Missing Trial DLL\n";
		return -1; // Missing Trial DLL;
	}

	TrialFcn displayRegProc = reinterpret_cast<TrialFcn>(
		::GetProcAddress(hModule, "DisplayRegistrationStr"));

	if (displayRegProc == NULL)
	{
		std::cout << "Missing Trial DLL for the second time\n";
		return -1; // Missing Trial DLL;
	}

	// Return values:
	// "0" - the application is registered (a valid license key was found/entered);
	// "2" - the application is in trial mode;
	int ret = displayRegProc(aKeyCode, aHWnd);
	std::cout << "Registration should have been shown!\n";
	::FreeLibrary(hModule);

	return ret;
}

int RegisterLicense(LPCSTR aKeyCode, LPCWSTR aLicense)
{
	HMODULE hModule = ::LoadLibrary(_T("Trial.dll"));
	if (hModule == NULL)
		return -1; // Missing Trial DLL;

	RegisterFcn registerLicense = reinterpret_cast<RegisterFcn>(
		::GetProcAddress(hModule, "RegisterStr"));

	if (registerLicense == NULL)
		return -1; // Missing Trial DLL;

	// Return values:
	// "0" - the license was successfully saved on local machine; notice that the license validation is not done when using the "RegisterStr" function
	// "different than 0" - the license couldn't be saved on local machine
	int ret = registerLicense(aKeyCode, aLicense);

	::FreeLibrary(hModule);

	return ret;
}